local BaikCore = LibStub("AceAddon-3.0"):GetAddon("BaikCore")
local Assert = BaikCore.Assert
local Log = BaikCore.Log

-- Add Module
local CombatSafe = BaikCore:NewModule("CombatSafe", "AceEvent-3.0")
BaikCore.CombatSafe = CombatSafe

-- Private Variables
local actions = {}

-- Private Methods
local function InCombat()
    return InCombatLockdown()
end

local function RunActions()
    if InCombat() then
        Log:e("CombatSafe_ExecCachedAction still in combat")
        return
    end

    for _, func in pairs(actions) do
        func()
    end
end

-- CombatSafe API
function CombatSafe:InLockdown()
    return InCombat()
end

function CombatSafe:Setup(func)
    Assert:Function(func)
    table.insert(actions, func)
end

function CombatSafe:PLAYER_ENTERING_WORLD()
    Log:d("CombatSafe:PLAYER_ENTERING_WORLD")
    RunActions()
end

function CombatSafe:PLAYER_REGEN_ENABLED()
    Log:d("CombatSafe:PLAYER_REGEN_ENABLED")
    RunActions()
end

-- Ace3 Callbacks
function CombatSafe:OnInitialize()
end

function CombatSafe:OnEnable()
    self:RegisterEvent("PLAYER_ENTERING_WORLD")
    self:RegisterEvent("PLAYER_REGEN_ENABLED")
end

function CombatSafe:OnDisable()
end
