local BaikCore = LibStub("AceAddon-3.0"):GetAddon("BaikCore")
local Option = BaikCore.Option

-- Add Module
local Reload = BaikCore:NewModule("Reload", "AceHook-3.0")
BaikCore.Reload = Reload

-- Constants
local OPT_NAME = "reload"

-- Private Variables
local needReload = false

-- Private Methods
local function TryReload(self, button, down)
    if needReload and button then
        Option:SetHidden(true, OPT_NAME)
        ReloadUI()
    end
end

local function GetOpt()
    return {
        name = "|cffff0000 RELOAD UI",
        type = "description",
        fontSize = "large",
        hidden = true,
        order = -1,
    }
end

-- Reload API
function Reload:Enable()
    needReload = true
    Option:SetHidden(false, OPT_NAME)
end

-- Ace3 Callbacks
function Reload:OnInitialize()
    Option:AddCategory(OPT_NAME, GetOpt())
end

function Reload:OnEnable()
    self:HookScript(InterfaceOptionsFrameOkay, "OnClick", TryReload)
end

function Reload:OnDisable()
    self:UnhookScript(InterfaceOptionsFrameOkay, "OnClick")
end
