local BaikCore = LibStub("AceAddon-3.0"):GetAddon("BaikCore")

-- Add Module
local Assert = {}
BaikCore.Assert = Assert

function Assert:True(value, msg)
    if not msg then
        msg = "Value is not true"
    end
    assert(value, msg)
end

function Assert:False(value, msg)
    if not msg then
        msg = "Value is not false"
    end
    assert(not value, msg)
end

function Assert:Null(value, msg)
    if not msg then
        msg = "Value is not null"
    end
    assert(value == nil, msg)
end

function Assert:NotNull(value, msg)
    if not msg then
        msg = "Value is null"
    end
    assert(value ~= nil, msg)
end

-- Type Assert
local function AssertType(vType, value, msg)
    valueType = type(value)
    if not msg then
        msg = "Value is not a " .. vType .. " it is " .. valueType
    end
    assert(valueType == vType, msg)
end

function Assert:Number(value, msg)
    AssertType("number", value, msg)
end

function Assert:String(value, msg)
    AssertType("string", value, msg)
end

function Assert:Function(value, msg)
    AssertType("function", value, msg)
end

function Assert:Table(value, msg)
    AssertType("table", value, msg)
end

function Assert:Boolean(value, msg)
    AssertType("boolean", value, msg)
end
