local BaikCore = LibStub("AceAddon-3.0"):GetAddon("BaikCore")
local Assert = BaikCore.Assert

-- Add Module
local OrderNumber = {}
OrderNumber.__index = OrderNumber
BaikCore.OrderNumber = OrderNumber

-- Constants
local CLASS = "OrderNumber"

-- LayoutAttrib API
function OrderNumber:Create(orderStart)
    -- Initialize order start
    if orderStart == nil then
        orderStart = 0
    end
    Assert:Number(orderStart)

    local self = {}
    setmetatable(self, OrderNumber)

    -- Setup member variables
    self.order = orderStart

    return self
end

function OrderNumber:GetNext()
    local curOrder = self.order
    self.order = curOrder + 1

    return curOrder
end

function OrderNumber:Set(value)
    Assert:Number(value)

    self.order = value
end
